execute as @a store result score @s dev_x run data get entity @s Pos[0]
execute as @a store result score @s dev_y run data get entity @s Pos[1]
execute as @a store result score @s dev_z run data get entity @s Pos[2]
title @a[tag=dev] actionbar [{"text":"X: "},{"score":{"name":"*","objective":"dev_x"},"color":"gold"},{"text":" Y: "},{"score":{"name":"*","objective":"dev_y"},"color":"light_purple"},{"text":" Z: "},{"score":{"name":"*","objective":"dev_z"},"color":"aqua"}]
gamemode adventure @a[tag=!dev]


tp @a[tag=start_sequence] -4 1 0 -90 -90
execute as @a[x=7, z=-4, dx=8, dz=8, tag=!room_1] run function ailab:fn/room_1

execute as @e[x=15, z=0, dx=.1, dz=.1, type=item] unless block 16 0 0 air run function ailab:fn/room_2_open

execute as @a at @s if block ~ ~0.1 ~ chain run tag @a add laser
execute as @a at @s if block ~ ~1.1 ~ chain run tag @a add laser
execute as @a at @s if block ~ ~1.7 ~ chain run tag @a add laser
tag @a[tag=laser] add laser_reason
execute as @a at @s run playsound minecraft:block.fire.extinguish player @a[tag=laser]
kill @a[tag=laser]
tag @a remove laser

execute as @a[scores={death_event=1..}] run function ailab:fn/on_death
spawnpoint @a -14 15 0

execute as @e[type=falling_block] run data modify entity @s Time set value 50

execute as @e[x=35, z=-1, dx=1, dz=3, type=item] unless block 35 0 -1 air run function ailab:fn/room_3_open

execute if block 53 1 0 minecraft:stone_button[face=wall, facing=west, powered=true] run function ailab:fn/room_4_button_1

execute if entity @a[nbt={Inventory:[{id: "minecraft:crafting_table"}]}] unless entity @a[nbt={Inventory:[{id: "minecraft:crafting_table", tag: {CanPlaceOn: ["minecraft:light_gray_stained_glass_pane"]}}]}] run function ailab:fn/room_4_crafting_table
execute if entity @a[nbt={Inventory:[{id: "minecraft:tnt"}]}] unless entity @a[nbt={Inventory:[{id: "minecraft:tnt", tag: {CanPlaceOn: ["minecraft:gray_concrete"]}}]}] run function ailab:fn/room_4_tnt_get

execute if block 34 0 -4 tnt run function ailab:fn/room_4_tnt_place

execute as @e[type=item] at @s if block ~ ~-0.5 ~ red_concrete run function ailab:fn/room_4_item1
execute as @e[type=item] at @s if block ~ ~-0.5 ~ yellow_concrete run function ailab:fn/room_4_item2
execute as @e[type=item] at @s if block ~ ~-0.5 ~ orange_concrete run function ailab:fn/room_4_item3

execute if entity @a[tag=item1, tag=item2, tag=item3] run function ailab:fn/room_4_end

execute as @e[type=item, nbt={Item: {id: "minecraft:repeater"}}] run data modify entity @s Item.tag.CanPlaceOn set value ["minecraft:blue_concrete"]

execute as @a[x=82, z=-19, dx=40, dz=40, y=0, dy=100, tag=!room_6] run function ailab:fn/room_6_open

execute as @e[type=warden, limit=1] store result bossbar minecraft:warden value run data get entity @s Health

execute if entity @a[tag=room_6] unless entity @e[type=warden] run function ailab:fn/room_7_open

effect clear @a darkness

bossbar set minecraft:warden players @a
bossbar set minecraft:warden color red
bossbar set minecraft:warden max 500
bossbar set minecraft:warden style notched_20

execute unless entity @e[type=warden] run bossbar remove minecraft:warden
execute as @e[type=minecraft:armor_stand] at @s rotated as @s positioned as @s run tp @s ^ ^ ^ ~-8 ~
scoreboard players enable a armor_stand
scoreboard players enable b armor_stand
scoreboard players set a armor_stand 0
scoreboard players set b armor_stand 1
execute as @e[type=armor_stand] run scoreboard players add a armor_stand 1
execute if score a armor_stand > b armor_stand run kill @e[type=armor_stand]
execute if score a armor_stand > b armor_stand run function ailab:fn/armor_stand

# TODO: warden fix
# TODO: remove chain/laser sound